<template>
  <background class="row q-gutter-md justify-center">
    <q-card class="col-lg-5 col-md-5 col-sm-10 col-xs-10">
      <q-card-section>
        <q-tabs
          v-model="tab"
          dense
          active-color="primary"
          indicator-color="primary"
          align="justify"
        >
          <q-tab
            name="hardware"
            label="Hardware"
          />
          <q-tab
            name="delay"
            label="Zpoždění dojezdu"
          />
          <q-tab
            name="position"
            label="Pozice vlaků"
          />
        </q-tabs>

        <q-separator />
        <q-tab-panels
          v-model="tab"
        >
          <q-tab-panel
            name="hardware"
            animated
            class="column text-center justify-center"
          >
            <div class="text-h4">
              Nastavení hardware
            </div>
            <q-select
              v-model="unit"
              class="q-mt-lg"
              :options="unitOptions"
              label="Jednotka"
            />
            <q-btn
              class="q-mt-lg"
              label="Zapnout napájení"
              @click="powerOn"
            />
            <q-btn
              class="q-mt-lg"
              label="Vypnout napájení"
              @click="powerOff"
            />
            <q-btn
              class="q-mt-lg"
              label="Restartovat můstkový usměrňovač"
              @click="resetRectifier"
            />
            <q-btn
              class="q-mt-lg"
              label="Restartovat mikroprocesor"
              @click="resetProc"
            />

            <div class="text-h6 q-my-lg">
              Zpoždění posílání proudu
            </div>

            <q-slider
              class="q-mt-lg"
              :min="1"
              :max="255"
              :step="1"
              snap
              label
              label-always
              color="primary"
              @change="currentChange"
            />
          </q-tab-panel>

          <q-tab-panel
            name="delay"
            animated
            class="column text-center justify-center"
          >
            <div class="text-h4">
              Nastavení zpoždění dojezdu
            </div>

            <div>
              <div
                v-for="station in stationAll"
                :key="station.id"
              >
                <div
                  v-for="train in trainAll"
                  :key="train.id"
                  class="row q-mt-lg"
                >
                  <div class="col-3 q-px-md">
                    {{ station.name }}
                  </div>
                  <div class="col-3 q-px-md">
                    {{ train.name }}
                  </div>
                  <div class="col-6 q-px-md">
                    <q-slider
                      :min="0"
                      :max="10000"
                      :step="1"
                      :model-value="getDelay(train.id, station.id)"
                      snap
                      label
                      label-always
                      color="primary"
                      @change="(val) => delayChange({delay: val, trainId: train.id, stationId: station.id})"
                    />
                  </div>
                </div>
              </div>
            </div>
          </q-tab-panel>
          <q-tab-panel
            name="position"
            animated
            class="column text-center justify-center"
          >
            <div
              v-for="train in trainAll"
              :key="train.id"
              class="row q-mt-lg"
            >
              <div class="col">
                {{ train.name }}
              </div>
              <div class="col">
                <q-select
                  v-model="train.position"
                  :options="stationOptions"
                  option-value="id"
                  option-label="name"
                />
              </div>
            </div>
          </q-tab-panel>
        </q-tab-panels>
      </q-card-section>
    </q-card>
  </background>
</template>

<script lang="ts">
import { ref } from '@vue/reactivity'
import { watch } from '@vue/runtime-core'
import _ from 'lodash'
import { useQuasar } from 'quasar'
import { DelayModel, DelayPut, StationModel, TrainModel, unitInstruction } from 'web_trains_types'

import background from '@/components/Background.vue'
import { adminHardwareService, delayService, trainService } from '@/service'

const unitOptions = [
  3, 4
]

export default {
  name: 'AdminHardware',
  components: {
    background
  },
  setup (): any {
    const $q = useQuasar()

    const unit = ref(3)
    const stationAll = ref<StationModel[]>([])
    const stationOptions = ref<StationModel[]>([])
    const trainAll = ref<TrainModel[]>([])
    const delayAll = ref<DelayModel[]>([])

    $q.loading.show()

    adminHardwareService.connect()

    const handlePositionChange = (newVal: TrainModel) => {
      if (newVal.position === undefined) {
        return
      }

      trainService.setPosition({
        trainId: newVal.id,
        positionId: newVal.position.id === 0 ? null : newVal.position.id
      })
        .then(() => {
          $q.notify({
            message: 'Úspěšně změněno, pro zobrazení změn obnovte stránku',
            type: 'positive'
          })
        })
    }

    delayService.getAll()
      .then((data) => {
        stationAll.value = data.station
        trainAll.value = data.train
        delayAll.value = data.delay

        stationOptions.value = _.clone(data.station)

        stationOptions.value.unshift({
          id: 0,
          name: 'NEOSAZEN',
          tcpName: ''
        })

        trainAll.value.forEach((val) => {
          val.position = stationOptions.value.find((station) => (station.id === 0 ? null : station.id) === val.positionId)
          watch(() => _.clone(val), handlePositionChange)
        })
      })
      .finally(() => $q.loading.hide())

    const delayChange = (data: DelayPut) => {
      $q.loading.show()
      delayService.put(data)
        .then(() => {
          $q.notify({
            message: 'Úspěšně změněno',
            type: 'positive'
          })
        })
        .finally(() => $q.loading.hide())
    }

    const getDelay = (trainId: number, stationId: number): number => {
      const val = delayAll.value
        .find((element) => element.trainId === trainId && element.stationId === stationId)
      return val ? val.delay : 0
    }

    const notifySuccess = (state: boolean) => {
      if (!state) {
        return
      }

      $q.notify({
        message: 'Úspěšně odesláno',
        type: 'positive'
      })
    }

    return {
      unitOptions,
      unit,
      powerOn: () => adminHardwareService.unitInstruction(unitInstruction.powerOn, unit.value).then(notifySuccess),
      powerOff: () => adminHardwareService.unitInstruction(unitInstruction.powerOff, unit.value).then(notifySuccess),
      resetRectifier: () => adminHardwareService.unitInstruction(unitInstruction.resetRectifier, unit.value).then(notifySuccess),
      resetProc: () => adminHardwareService.unitInstruction(unitInstruction.resetProcesor, unit.value).then(notifySuccess),
      currentChange: (current: number) => adminHardwareService.unitInstruction(unitInstruction.currentDelay, unit.value, current).then(notifySuccess),
      tab: ref('hardware'),
      stationAll,
      trainAll,
      delayAll,
      delayChange,
      getDelay,
      stationOptions
    }
  }
}

</script>
